﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

namespace MyFirstASPNetCoreWebAPI.WebAPI
{
    [Route("api/[controller]")]
    public class TestingController : Controller
    {
        //Get /api/testing
        [HttpGet]
        public string Get()
        {
            return "Welcome to your first ASP.Net Core Web API Tutorial. ";
        }

        //Get /api/testing/value1
        [HttpGet("{value}")]
        public string Get(string value)

        {
            return "You have entered a string value : " + value;
        }


        //Get /api/testing/value1/value2/value3
        [HttpGet("{value1}/{value2}/{value3?}")]
        public string Get(int value1, int value2, int? value3)
        {
            if (value3.HasValue)
            {
                return "You have entered a three int values : " + value1 + " " + value2 + " " + value3;
            }
            else
            {
                return "You have entered a two int values : " + value1 + " " + value2;
            }
            
        }

        //Get /api/testing/GetProducts
        [HttpGet("GetProducts")]
        public IEnumerable<string> GetProducts()

        {
            return new string[] { "product1", "product2" };
        }

        //Get /api/testing/GetItems/2
        [HttpGet("GetItems/{value}")]
        public IEnumerable<string> GetItems(string value)
        {
            return new string[] { "item1", "item2" };
        }

        //Post /api/testing/PostItems
        [HttpPost("PostItems")]
        public string PostItems()
        {
            return "You have performed a basic post.";
        }

        ////Post /api/testing/PostItemsWithInt
        [HttpPost("PostItemsWithInt")]
        public string PostItemsWithInt([FromBody] int num)
        {
            return "You have post a message int value: " + num.ToString();
        }

        
    }
}
